module GitPunch
  class Client
    include HTTParty

    base_uri "notepunch.com"

    def initialize
      @user = User.from_config
    end

    def post url, body
      request = {
        body: body,
        basic_auth: user.credentials,
        content_type: 'application/json'
      }

      self.class.post url, request
    end

    def get url
      self.class.get url, content_type: 'application/json'
    end
  end
end
