module GitPunch
  class ClientErrors
    include Enumerable

    def initialize
      @collection = Hash.new
    end

    def each
      collection.each { |item| yield item }
    end

    def to_s
      combined.join ', '
    end

    def add attribute, message
      collection[attribute] ||= Array.new

      collection[attribute].push message
    end

    def << hash_of_arrays
      collection.merge hash_of_arrays
    end

    def any?
      collection.any?
    end

    def messages
      reduce([]) do |error_messages, (attribute,messages)|
        error_messages << messages.reduce([]) do |all,message|
          all << "#{attribute} #{message}"
        end
      end
    end

    def attributes
      collection.keys.uniq
    end

  private
    def collection
      @collection ||= Hash.new
    end
  end
end
