module GitPunch
  module MediaConfig
    def git_media_config
      config_template.result context
    end

    def repo
      @repo ||= Repository.new
    end

  private
    def context
      instance_eval 'binding'
    end

    def config_template
      ERB.new from_source
    end

    def from_source
      File.binread "#{GitPunch.template_path}/gitconfig.erb"
    end
  end
end
