require 'git_punch/user'

module GitPunch
  class Repository
    attr_accessor :path, :user

    def initialize options={}
      @path = options[:from]
      @user = if options[:user].nil?
        User.from_config
      else
        create_user_from options[:user]
      end
    end

    def name
      File.basename path
    end

    def self.current!
      new from: ENV['PWD']
    end

  private
    def create_user_from param
      if param.is_a? String
        User.new name: param
      else
        param
      end
    end
  end
end
