module GitPunch
  class Song
    attr_accessor :attributes, :is_fork, :original_user, :original_song_id

    alias is_fork? is_fork

    def initialize with_options={}
      @attributes = with_options.reduce({}) do |attrs,opt,val|
        send "#{opt}=", val if respond_to? opt
        attrs.merge opt => val
      end

    end

    def self.fork with_options={}
      new with_options.merge \
        is_fork: true,
        original_user: User.from_origin.name
    end

    def valid?
      if is_fork? && original_user.present?
        fork_url = "/songs/#{original_song_id}/fork"
        create_repository_at fork_url
      else
        create_repository_at "/songs"
      end
    end

    def errors
      @errors ||= ClientErrors.new
    end

  private
    def create_repository_at url
      request = note_punch.post url, attrbutes
      response = JSON.parse request.body
      status = request.status

      unless status == '200'
        errors << response['errors']
      end

      errors.add JSON.parse(response.body)['errors'] \
        unless response.status == '200'
    end

    def note_punch
      @client ||= Client.new
    end
  end
end
