require 'fileutils'

namespace :clean do
  task :filesystem do
    include FileUtils

    sh 'git checkout HEAD .gitignore'

    %w(.gitattributes .git/hooks/post-commit).each do |config_file|
      rm config_file if File.exists? config_file
    end
    mv '.git/config.backup', '.git/config' \
      if File.exists? '.git/config.backup'
  end
end

desc "Clean up any generated files left over from testing."
task :clean => ['clean:filesystem']
